<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/ModuleFilter.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/ModuleFilter.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/ModuleFilter.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Processor, Parameter</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html">ModuleFilter</a>(Processor, ASG.Visitor):</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A processor that filters modules.&quot;&quot;&quot;</span></span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">    modules = Parameter([], <span class="py-string">'List of modules to be filtered out.'</span>)</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    remove_empty = Parameter(True, <span class="py-string">'Whether or not to remove empty modules.'</span>)</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line18"></a><span class="lineno">18</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        self.__scopestack = []</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        self.__currscope = []</span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        <span class="py-keyword">for</span> decl <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">           decl.accept(self)</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        self.ir.asg.declarations[:] = self.__currscope</span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#push">push</a>(self):</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Pushes the current scope onto the stack and starts a new one&quot;&quot;&quot;</span></span>
<a id="line33"></a><span class="lineno">33</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        self.__scopestack.append(self.__currscope)</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">        self.__currscope = []</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#pop">pop</a>(self, decl):</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Pops the current scope from the stack, and appends the given</span></span>
<a id="line39"></a><span class="lineno">39</span><span class="line"><span class="py-string">        declaration to it&quot;&quot;&quot;</span></span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        self.__currscope = self.__scopestack.pop()</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        self.__currscope.append(decl)</span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#pop_only">pop_only</a>(self):</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Only pops, doesn't append to scope&quot;&quot;&quot;</span></span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        self.__currscope = self.__scopestack.pop()</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#add">add</a>(self, decl):</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Adds the given decl to the current scope&quot;&quot;&quot;</span></span>
<a id="line51"></a><span class="lineno">51</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        self.__currscope.append(decl)</span>
<a id="line53"></a><span class="lineno">53</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Adds declaration to scope&quot;&quot;&quot;</span></span>
<a id="line56"></a><span class="lineno">56</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">        self.add(decl)</span>
<a id="line58"></a><span class="lineno">58</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">    visit_builtin = visit_declaration</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">    visit_group = visit_declaration</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">    visit_scope = visit_declaration</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">    visit_enum = visit_declaration</span>
<a id="line63"></a><span class="lineno">63</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/ModuleFilter/ModuleFilter.html#visit_module">visit_module</a>(self, module):</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Visits all children of the module, and if there are no declarations</span></span>
<a id="line66"></a><span class="lineno">66</span><span class="line"><span class="py-string">        after that removes the module&quot;&quot;&quot;</span></span>
<a id="line67"></a><span class="lineno">67</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">        <span class="py-keyword">if</span> module.name <span class="py-keyword">in</span> self.modules:</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line70"></a><span class="lineno">70</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        self.push()</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> module.declarations:</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">            d.accept(self)</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">        module.declarations = self.__currscope</span>
<a id="line75"></a><span class="lineno">75</span><span class="line">        <span class="py-comment"># count the number of non-forward declarations in the current scope</span></span>
<a id="line76"></a><span class="lineno">76</span><span class="line">        count = reduce(<span class="py-keyword">lambda</span> x, y: x + y,</span>
<a id="line77"></a><span class="lineno">77</span><span class="line">                       [<span class="py-keyword">not</span> isinstance(x, (ASG.Forward, ASG.Builtin))</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">                                       <span class="py-keyword">for</span> x <span class="py-keyword">in</span> self.__currscope],</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">                       0)</span>
<a id="line80"></a><span class="lineno">80</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.remove_empty <span class="py-keyword">or</span> count: self.pop(module)</span>
<a id="line81"></a><span class="lineno">81</span><span class="line">        <span class="py-keyword">else</span>: self.pop_only()</span>
<a id="line82"></a><span class="lineno">82</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
